Entity/ProductionMembership.php
<?php

declare(strict_types=1);

/*
 * This file is part of the BkstgFOSUserBundle package.
 * (c) Luke Bainbridge <http://www.lukebainbridge.ca/>
 * For the full copyright and license information, please view the LICENSE
 * file that was distributed with this source code.
 */

namespace Bkstg\FOSUserBundle\Entity;

use Bkstg\CoreBundle\Entity\Production;
use Bkstg\CoreBundle\Model\ActiveInterface;
use Bkstg\CoreBundle\Model\ExpirableInterface;
use Bkstg\CoreBundle\User\ProductionMembershipInterface;
use Doctrine\Common\Collections\ArrayCollection;
use MidnightLuke\GroupSecurityBundle\Model\GroupInterface;
use MidnightLuke\GroupSecurityBundle\Model\GroupMemberInterface;

class ProductionMembership implements ProductionMembershipInterface, ActiveInterface, ExpirableInterface
{
    const GROUP_ROLE_DEFAULT = 'GROUP_ROLE_USER';

    private $id;
    private $group;
    private $member;
    private $roles;
    private $active;
    private $expiry;
    private $production_roles;

    /**
     * Create a new production membership.
     */
    public function __construct()
    {
        $this->production_roles = new ArrayCollection();
        $this->roles = [];
    }

    /**
     * Get the id.
     *
     * @return ?int
     */
    public function getId(): ?int
    {
        return $this->id;
    }

    /**
     * Get the group for this membership.
     *
     * @return ?GroupInterface
     */
    public function getGroup(): ?GroupInterface
    {
        return $this->group;
    }

    /**
     * Set the group for this membership.
     *
     * @param GroupInterface $group The group to set.
     *
     * @throws \Exception When the group is not a production.
     *
     * @return self
     */
    public function setGroup(GroupInterface $group): self
    {
        if (!$group instanceof Production) {
            throw new \Exception(sprintf('The group type "%s" is not supported.', get_class($group)));
        }
        $this->group = $group;

        return $this;
    }

    /**
     * Get the group member for this membership.
     *
     * @return ?GroupMemberInterface
     */
    public function getMember(): ?GroupMemberInterface
    {
        return $this->member;
    }

    /**
     * Set the member for this membership.
     *
     * @param GroupMemberInterface $member The member to set.
     *
     * @throws \Exception If the member is not a User.
     *
     * @return self
     */
    public function setMember(GroupMemberInterface $member): self
    {
        if (!$member instanceof User) {
            throw new \Exception(sprintf('The member type "%s" is not supported.', get_class($member)));
        }
        $this->member = $member;

        return $this;
    }

    /**
     * Get the roles for this membership.
     *
     * @return array
     */
    public function getRoles(): array
    {
        // Always add the default role.
        $roles = $this->roles;
        $roles[] = self::GROUP_ROLE_DEFAULT;

        return array_unique($roles);
    }

    /**
     * Set all the roles for this membership.
     *
     * @param array $roles An array of roles.
     *
     * @return self
     */
    public function setRoles(array $roles): self
    {
        // Reset and populate the roles.
        $this->roles = [];
        foreach ($roles as $role) {
            $this->addRole($role);
        }

        return $this;
    }

    /**
     * Add a role to this membership.
     *
     * @param string $role The role to add.
     *
     * @return self
     */
    public function addRole(string $role): self
    {
        $role = strtoupper($role);

        // Don't add the default role, it is always present.
        if (self::GROUP_ROLE_DEFAULT === $role) {
            return $this;
        }

        // Don't duplicate any roles.
        if (!in_array($role, $this->roles, true)) {
            $this->roles[] = $role;
        }

        return $this;
    }

    /**
     * Remove a role from this membership.
     *
     * @param string $role The role to remove.
     *
     * @return self
     */
    public function removeRole(string $role): self
    {
        if (false !== $key = array_search(strtoupper($role), $this->roles, true)) {
            unset($this->roles[$key]);
            $this->roles = array_values($this->roles);
        }

        return $this;
    }

    /**
     * Determine if this membership has a role.
     *
     * @param string $role The role to check for.
     *
     * @return bool
     */
    public function hasRole(string $role): bool
    {
        return in_array(strtoupper($role), $this->getRoles(), true);
    }

    /**
     * Get the active of this membership.
     *
     * @return bool
     */
    public function isActive(): bool
    {
        return true === $this->active;
    }

    /**
     * Set the active of this membership.
     *
     * @param bool $active The active to set.
     *
     * @return self
     */
    public function setActive(bool $active): self
    {
        $this->active = $active;

        return $this;
    }

    /**
     * Get the expiry for this membership.
     *
     * @return ?\DateTimeInterface
     */
    public function getExpiry(): ?\DateTimeInterface
    {
        return $this->expiry;
    }

    /**
     * Set the expiry for this membership.
     *
     * @param ?\DateTimeInterface $expiry The expiry to set.
     *
     * @return self
     */
    public function setExpiry(?\DateTimeInterface $expiry): self
    {
        $this->expiry = $expiry;

        return $this;
    }

    /**
     * Check if this membership is expired.
     *
     * @return bool
     */
    public function isExpired(): bool
    {
        return null !== $this->expiry && $this->expiry < new \DateTime('now');
    }

    /**
     * Add a production role to this membership.
     *
     * @param ProductionRole $production_role The production role to add.
     *
     * @return self
     */
    public function addProductionRole(ProductionRole $production_role): self
    {
        $production_role->setProductionMembership($this);
        $this->production_roles->add($production_role);

        return $this;
    }

    /**
     * Remove a production role from this membership.
     *
     * @param ProductionRole $production_role The production role to remove.
     *
     * @return self
     */
    public function removeProductionRole(ProductionRole $production_role): self
    {
        $this->production_roles->removeElement($production_role);

        return $this;
    }

    /**
     * Get the production roles.
     *
     * @return ArrayCollection
     */
    public function getProductionRoles()
    {
        return $this->production_roles;
    }

    /**
     * Return a string representation of the membership.
     *
     * @return string
     */
    public function __toString()
    {
        return $this->getMember()->__toString();
    }
}

Controller/ProductionMembershipController.php
<?php

declare(strict_types=1);

/*
 * This file is part of the BkstgFOSUserBundle package.
 * (c) Luke Bainbridge <http://www.lukebainbridge.ca/>
 * For the full copyright and license information, please view the LICENSE
 * file that was distributed with this source code.
 */

namespace Bkstg\FOSUserBundle\Controller;

use Bkstg\CoreBundle\Controller\Controller;
use Bkstg\CoreBundle\Entity\Production;
use Bkstg\FOSUserBundle\BkstgFOSUserBundle;
use Bkstg\FOSUserBundle\Entity\ProductionMembership;
use Bkstg\FOSUserBundle\Form\ProductionMembershipType;
use Doctrine\Common\Collections\ArrayCollection;
use Knp\Component\Pager\PaginatorInterface;
use Symfony\Component\HttpFoundation\RedirectResponse;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\HttpKernel\Exception\NotFoundHttpException;
use Symfony\Component\Security\Core\Authorization\AuthorizationCheckerInterface;
use Symfony\Component\Security\Core\Exception\AccessDeniedException;

class ProductionMembershipController extends Controller
{
    /**
     * Show a list of active memberships.
     *
     * @param string                        $production_slug The production slug.
     * @param Request                       $request         The incoming request.
     * @param AuthorizationCheckerInterface $auth            The authorization checker service.
     * @param PaginatorInterface            $paginator       The paginator service.
     *
     * @throws NotFoundHttpException If the production is not found.
     * @throws AccessDeniedException If the user is not an admin in the group.
     *
     * @return Response
     */
    public function indexAction(
        string $production_slug,
        Request $request,
        AuthorizationCheckerInterface $auth,
        PaginatorInterface $paginator
    ): Response {
        // Lookup the production by production_slug.
        $production_repo = $this->em->getRepository(Production::class);
        if (null === $production = $production_repo->findOneBy(['slug' => $production_slug])) {
            throw new NotFoundHttpException();
        }

        // Check permissions for this action.
        if (!$auth->isGranted('GROUP_ROLE_ADMIN', $production)) {
            throw new AccessDeniedException();
        }

        // Get active memberships.
        $query = $this->em->getRepository(ProductionMembership::class)->findAllActiveQuery($production);
        $memberships = $paginator->paginate($query, $request->query->getInt('page', 1));

        // Return the membership index.
        return new Response($this->templating->render(
            '@BkstgFOSUser/ProductionMembership/index.html.twig',
            [
                'production' => $production,
                'memberships' => $memberships,
            ]
        ));
    }

    /**
     * Show a list of archived memberships.
     *
     * @param string                        $production_slug The production slug.
     * @param Request                       $request         The incoming request.
     * @param AuthorizationCheckerInterface $auth            The authorization checker service.
     * @param PaginatorInterface            $paginator       The paginator service.
     *
     * @throws NotFoundHttpException If the production is not found.
     * @throws AccessDeniedException If the user is not an admin in the group.
     *
     * @return Response
     */
    public function archiveAction(
        string $production_slug,
        Request $request,
        AuthorizationCheckerInterface $auth,
        PaginatorInterface $paginator
    ): Response {
        // Lookup the production by production_slug.
        $production_repo = $this->em->getRepository(Production::class);
        if (null === $production = $production_repo->findOneBy(['slug' => $production_slug])) {
            throw new NotFoundHttpException();
        }

        // Check permissions for this action.
        if (!$auth->isGranted('GROUP_ROLE_ADMIN', $production)) {
            throw new AccessDeniedException();
        }

        // Get archived memberships.
        $query = $this->em->getRepository(ProductionMembership::class)->findAllInactiveQuery($production);
        $memberships = $paginator->paginate($query, $request->query->getInt('page', 1));

        // Return the membership archive.
        return new Response($this->templating->render(
            '@BkstgFOSUser/ProductionMembership/archive.html.twig',
            [
                'production' => $production,
                'memberships' => $memberships,
            ]
        ));
    }

    /**
     * Create a new membership in this group.
     *
     * @param string                        $production_slug The production slug.
     * @param Request                       $request         The incoming request.
     * @param AuthorizationCheckerInterface $auth            The authorization checker service.
     *
     * @throws NotFoundHttpException If the production is not found.
     * @throws AccessDeniedException If the user is not an admin in the group.
     *
     * @return Response
     */
    public function createAction(
        string $production_slug,
        Request $request,
        AuthorizationCheckerInterface $auth
    ): Response {
        // Lookup the production by production_slug.
        $production_repo = $this->em->getRepository(Production::class);
        if (null === $production = $production_repo->findOneBy(['slug' => $production_slug])) {
            throw new NotFoundHttpException();
        }

        // Check permissions for this action.
        if (!$auth->isGranted('GROUP_ROLE_ADMIN', $production)) {
            throw new AccessDeniedException();
        }

        // Create a new production_membership.
        $membership = new ProductionMembership();
        $membership->setActive(true);
        $membership->setGroup($production);

        // Create and handle the form.
        $form = $this->form->create(ProductionMembershipType::class, $membership);
        $form->handleRequest($request);

        // Form is submitted and valid.
        if ($form->isSubmitted() && $form->isValid()) {
            // Persist the production
            $this->em->persist($membership);
            $this->em->flush();

            // Set success message and redirect.
            $this->session->getFlashBag()->add(
                'success',
                $this->translator->trans('production_membership.created', [
                    '%user%' => $membership->getMember()->__toString(),
                    '%production%' => $production->getName(),
                ], BkstgFOSUserBundle::TRANSLATION_DOMAIN)
            );

            return new RedirectResponse($this->url_generator->generate('bkstg_production_membership_index', [
                'production_slug' => $production->getSlug(),
            ]));
        }

        // Render the form.
        return new Response($this->templating->render('@BkstgFOSUser/ProductionMembership/create.html.twig', [
            'production' => $production,
            'form' => $form->createView(),
        ]));
    }

    /**
     * Update an existing group membership.
     *
     * @param string                        $production_slug The production slug.
     * @param int                           $id              The membership id.
     * @param Request                       $request         The incoming request.
     * @param AuthorizationCheckerInterface $auth            The authorization checker service.
     *
     * @throws NotFoundHttpException If the production is not found.
     * @throws AccessDeniedException If the user is not an admin in the group.
     *
     * @return Response
     */
    public function updateAction(
        string $production_slug,
        int $id,
        Request $request,
        AuthorizationCheckerInterface $auth
    ): Response {
        // Lookup the production by production_slug.
        $production_repo = $this->em->getRepository(Production::class);
        if (null === $production = $production_repo->findOneBy(['slug' => $production_slug])) {
            throw new NotFoundHttpException();
        }

        // Lookup the membership by production and id.
        $membership_repo = $this->em->getRepository(ProductionMembership::class);
        if (null === $membership = $membership_repo->findOneBy(['group' => $production, 'id' => $id])) {
            throw new NotFoundHttpException();
        }

        // Ensure this membership is for this group.
        if ($membership->getGroup() !== $production) {
            throw new NotFoundHttpException();
        }

        // Check permissions for this action.
        if (!$auth->isGranted('GROUP_ROLE_ADMIN', $production)) {
            throw new AccessDeniedException();
        }

        // Create an index of production roles for checking later.
        $production_roles = new ArrayCollection();
        foreach ($membership->getProductionRoles() as $production_role) {
            $production_roles->add($production_role);
        }

        // Create and handle the form.
        $form = $this->form->create(ProductionMembershipType::class, $membership);
        $form->handleRequest($request);

        // Form is submitted and valid.
        if ($form->isSubmitted() && $form->isValid()) {
            // Remove unneeded production_roles.
            foreach ($production_roles as $production_role) {
                if (false === $membership->getProductionRoles()->contains($production_role)) {
                    $this->em->remove($production_role);
                }
            }

            // Persist the production
            $this->em->persist($membership);
            $this->em->flush();

            // Set success message and redirect.
            $this->session->getFlashBag()->add(
                'success',
                $this->translator->trans('production_membership.updated', [

Resources/views/ProductionMembership/_actions-index.html.twig
{% trans_default_domain 'BkstgFOSUserBundle' %}

{% set route = app.request.attributes.get('_route') %}
<ul class="nav nav-tabs mb-3">
  <li class="nav-item">
    <a class="nav-link{% if route == 'bkstg_production_membership_index' %} active{% endif %}" href="{{ url('bkstg_production_membership_index', { 'production_slug': production.slug }) }}">{{ 'production_membership.list'|trans }}</a>
  </li>
  <li class="nav-item">
    <a class="nav-link{% if route == 'bkstg_production_membership_archive' %} active{% endif %}" href="{{ url('bkstg_production_membership_archive', { 'production_slug': production.slug }) }}">{{ 'production_membership.archive'|trans }}</a>
  </li>
</ul>

Resources/views/ProductionMembership/_actions.html.twig
{% trans_default_domain 'BkstgFOSUserBundle' %}

{% set route = app.request.attributes.get('_route') %}
<ul class="nav nav-tabs mb-3">
  <li class="nav-item">
    <a class="nav-link{% if route == 'bkstg_production_membership_update' %} active{% endif %}" href="{{ url('bkstg_production_membership_update', { 'production_slug': membership.group.slug, 'id': membership.id }) }}">{{ 'edit'|trans }}</a>
  </li>
  <li class="nav-item">
    <a class="nav-link{% if route == 'bkstg_production_membership_delete' %} active{% endif %} text-danger" href="{{ url('bkstg_production_membership_delete', { 'production_slug': membership.group.slug, 'id': membership.id }) }}">{{ 'delete'|trans }}</a>
  </li>
</ul>

Resources/views/ProductionMembership/_form.html.twig
{% trans_default_domain 'BkstgFOSUserBundle' %}

{% form_theme form '@BkstgFOSUser/ProductionRole/_form.html.twig' %}
{{ form_start(form) }}
  <div class="form-row">
    <div class="col-md-2">
      {{ form_row(form.active) }}
    </div>
    <div class="col">
      {{ form_row(form.member) }}
    </div>
  </div>
  {{ form_widget(form) }}
  <div class="form-group">
    <a href="{{ url('bkstg_production_membership_index', { 'production_slug': production.slug }) }}" class="btn btn-secondary">{{ 'cancel'|trans }}</a>
    <button type="submit" class="btn btn-primary">{{ 'save'|trans }}</button>
  </div>
{{ form_end(form) }}

Resources/views/ProductionMembership/archive.html.twig
{% extends '@BkstgCore/layout.html.twig' %}
{% trans_default_domain 'BkstgFOSUserBundle' %}
{% set page_title = 'production_membership.members'|trans({ '%production%': production.name }) %}

{% block content %}
  {# Archive information #}
  <div class="alert alert-info">
    {{ 'production_membership.archive_info'|trans }}
  </div>

  {# Table of existing memberships. #}
  <p>{% include '@BkstgFOSUser/ProductionMembership/_actions-index.html.twig' %}</p>
  <p><div class="table-responsive">
    <table class="table table-striped">
      <thead>
        <tr>
          <th></th>
          <th>{{ 'production_membership.label.user'|trans }}</th>
          <th>{{ 'production_membership.label.roles'|trans }}</th>
          <th>{{ 'production_membership.label.production_roles'|trans }}</th>
          <th>{{ 'production_membership.label.status'|trans }}</th>
          <th>{{ knp_pagination_sortable(memberships, 'production_membership.label.expiry'|trans, 'm.expiry') }}</th>
        </tr>
      </thead>
      <tbody>
        {% for membership in memberships %}
          <tr>
            <td>
              <div class="btn-group btn-group-sm">
                <a href="{{ url('bkstg_production_membership_update', { 'production_slug': production.slug, 'id': membership.id}) }}" class="btn btn-info"><i class="fa fa-pencil-alt" aria-hidden="true"></i><span class="sr-only">{{ 'edit'|trans }}</span></a>
                <a href="{{ url('bkstg_production_membership_delete', { 'production_slug': production.slug, 'id': membership.id}) }}" class="btn btn-danger"><i class="fa fa-trash" aria-hidden="true"></i><span class="sr-only">{{ 'delete'|trans }}</span></a>
              </div>
            </td>
            <td><a href="{{ url('bkstg_production_directory_read', { 'production_slug': production.slug, 'profile_slug': membership.member.slug }) }}">{{ membership.member }}</td>
            <td>
              <ul>
                {% for role in membership.roles %}
                  <li>{{ role }}</li>
                {% else %}
                  <li class="text-muted">{{ 'production_membership.no_roles'|trans }}</li>
                {% endfor %}
              </ul>
            </td>
            <td>
              <ul>
                {% for production_role in membership.productionRoles %}
                  <li><strong>{{ production_role.designation }}</strong>: {{ production_role.name }}</li>
                {% else %}
                  <li class="text-muted">{{ 'production_membership.no_production_roles'|trans }}</li>
                {% endfor %}
              </ul>
            </td>
            <td>{{ membership.expired ? 'production_membership.expired'|trans : membership.active ? 'production_membership.active'|trans : 'production_membership.blocked'|trans }}</td>
            <td>{{ membership.expiry ? membership.expiry|date(full_date) : '' }}</td>
          </tr>
        {% else %}
          <tr>
            <td colspan="6">{{ 'production_membership.archive_no_members'|trans }}</td>
          </tr>
        {% endfor %}
      </tbody>
    </table>
  </div></p>
  {{ knp_pagination_render(memberships) }}
{% endblock %}

Resources/views/ProductionMembership/create.html.twig
{% extends '@BkstgCore/layout.html.twig' %}
{% trans_default_domain 'BkstgFOSUserBundle' %}
{% set page_title = 'production_membership.create'|trans %}

{% block content %}
  {% include '@BkstgFOSUser/ProductionMembership/_form.html.twig' with { 'form': form, 'production': production } only %}
{% endblock %}

Resources/views/ProductionMembership/delete.html.twig
{% extends '@BkstgCore/layout.html.twig' %}
{% trans_default_domain 'BkstgFOSUserBundle' %}
{% set page_title = 'production_membership.delete'|trans({ '%user%': membership.member }) %}

{% block content %}
  {% include '@BkstgFOSUser/ProductionMembership/_actions.html.twig' with { 'membership': membership } only %}
  <p>{{ 'production_membership.delete_confirm'|trans({ '%user%': membership.member }) }}</p>
  <p>{{ 'production_membership.delete_consequences'|trans }}</p>
  <p><strong>{{ 'production_membership.delete_no_undo'|trans }}</strong></p>
  {{ form_start(form) }}
    {{ form_widget(form) }}
    <div class="form-group">
      <a href="{{ url('bkstg_user_admin_index') }}" class="btn btn-secondary">{{ 'cancel'|trans }}</a>
      <button type="submit" class="btn btn-danger">{{ 'delete'|trans }}</button>
    </div>
  {{ form_end(form) }}
{% endblock %}

Resources/views/ProductionMembership/index.html.twig
{% extends '@BkstgCore/layout.html.twig' %}
{% trans_default_domain 'BkstgFOSUserBundle' %}
{% set page_title = 'production_membership.members'|trans({ '%production%': production.name }) %}

{% block content %}
  {# Link to create a new membership. #}
  <a href="{{ url('bkstg_production_membership_create', { 'production_slug': production.slug }) }}" class="btn btn-success">
    <i class="fa fa-plus" aria-hidden="true"></i> {{ 'production_membership.create'|trans }}
  </a>

  {# Table of existing memberships. #}
  <p>{% include '@BkstgFOSUser/ProductionMembership/_actions-index.html.twig' %}</p>
  <p><div class="table-responsive">
    <table class="table table-striped">
      <thead>
        <tr>
          <th></th>
          <th>{{ 'production_membership.label.user'|trans }}</th>
          <th>{{ 'production_membership.label.roles'|trans }}</th>
          <th>{{ 'production_membership.label.production_roles'|trans }}</th>
          <th>{{ 'production_membership.label.status'|trans }}</th>
          <th>{{ knp_pagination_sortable(memberships, 'production_membership.label.expiry'|trans, 'm.expiry') }}</th>
        </tr>
      </thead>
      <tbody>
        {% for membership in memberships %}
          <tr>
            <td>
              <div class="btn-group btn-group-sm">
                <a href="{{ url('bkstg_production_membership_update', { 'production_slug': production.slug, 'id': membership.id}) }}" class="btn btn-info"><i class="fa fa-pencil-alt" aria-hidden="true"></i><span class="sr-only">{{ 'edit'|trans }}</span></a>
                <a href="{{ url('bkstg_production_membership_delete', { 'production_slug': production.slug, 'id': membership.id}) }}" class="btn btn-danger"><i class="fa fa-trash" aria-hidden="true"></i><span class="sr-only">{{ 'delete'|trans }}</span></a>
              </div>
            </td>
            <td>
              {% if membership.member.slug is not empty %}
                <a href="{{ url('bkstg_production_directory_read', { 'production_slug': production.slug, 'profile_slug': membership.member.slug }) }}">{{ membership.member }}</a>
              {% else %}
                {{ membership.member }}
              {% endif %}
            </td>
            <td>
              <ul>
                {% for role in membership.roles %}
                  <li>{{ role }}</li>
                {% else %}
                  <li class="text-muted">{{ 'production_membership.no_roles'|trans }}</li>
                {% endfor %}
              </ul>
            </td>
            <td>
              <ul>
                {% for production_role in membership.productionRoles %}
                  <li><strong>{{ production_role.designation }}</strong>: {{ production_role.name }}</li>
                {% else %}
                  <li class="text-muted">{{ 'production_membership.no_production_roles'|trans }}</li>
                {% endfor %}
              </ul>
            </td>
            <td>{{ membership.expired ? 'production_membership.expired'|trans : membership.active ? 'production_membership.active'|trans : 'production_membership.blocked'|trans }}</td>
            <td>{{ membership.expiry ? membership.date|date(full_date) : '' }}</td>
          </tr>
        {% else %}
          <tr>
            <td colspan="6">{{ 'production_membership.no_members'|trans }}</td>
          </tr>
        {% endfor %}
      </tbody>
    </table>
  </div></p>
  {{ knp_pagination_render(memberships) }}
{% endblock %}

Resources/views/ProductionMembership/update.html.twig
{% extends '@BkstgCore/layout.html.twig' %}
{% trans_default_domain 'BkstgFOSUserBundle' %}
{% set page_title = 'production_membership.edit'|trans({ '%user%': membership.member }) %}

{% block content %}
  {% include '@BkstgFOSUser/ProductionMembership/_actions.html.twig' with { 'membership': membership } only %}
  {% include '@BkstgFOSUser/ProductionMembership/_form.html.twig' with { 'form': form, 'production': production } only %}
{% endblock %}